module AMF
  module AMFConstants
    # AMF3 Type Markers
    AMF3_MARKER_UNDEFINED = 0x00 #"\000"
    AMF3_MARKER_NULL      = 0x01 #"\001"

    AMF3_MARKER_FALSE = 0x02 #"\002"
    AMF3_MARKER_TRUE  = 0x03 #"\003"

    AMF3_MARKER_INTEGER    = 0x04 #"\004"
    AMF3_MARKER_DOUBLE     = 0x05 #"\005"
    AMF3_MARKER_STRING     = 0x06 #"\006"
    AMF3_MARKER_XML_DOC    = 0x07 #"\a"   not supported
    AMF3_MARKER_DATE       = 0x08 #"\b"
    AMF3_MARKER_ARRAY      = 0x09 #"\t"
    AMF3_MARKER_OBJECT     = 0x0A #"\n"
    AMF3_MARKER_XML        = 0x0B #"\v"   not supported
    AMF3_MARKER_BYTE_ARRAY = 0x0C #"\f"

    AMF3_MARKER_VECTOR_INT    = 0x0D #"\r"    not supported
    AMF3_MARKER_VECTOR_UINT   = 0x0E #"\016"  not supported
    AMF3_MARKER_VECTOR_DOUBLE = 0x0F #"\017"  not supported
    AMF3_MARKER_VECTOR_OBJECT = 0x10 #"\020"  not supported

    AMF3_MARKER_DICTIONARY = 0x11 #"\021"

    # Other AMF3 Markers
    AMF3_EMPTY_STRING      = 0x01

    AMF3_CLOSE_DYNAMIC_OBJECT = 0x01
    AMF3_CLOSE_DYNAMIC_ARRAY  = 0x01

    # The minimum value for an integer that will avoid promotion to an ActionScript's Number type.
    INTEGER_MIN               = -268_435_456
    # The maximum value for an integer that will avoid promotion to an ActionScript's Number type.
    INTEGER_MAX               = 268_435_455

    MIN_INT_2_BYTE = 0x80
    MIN_INT_3_BYTE = 0x4000
    MIN_INT_4_BYTE = 0x200000
  end
end
